using UnityEngine;
using System.Collections.Generic;

public class DigitalClay : MonoBehaviour
{
    readonly List<Vector3> vertices = new List<Vector3>();
	//List<Vector2> UVs = new List<Vector2>();
    readonly List<int> triangles = new List<int>();
	List<int> surfaces = new List<int>();
    readonly List<Color> colors = new List<Color>();
	List<int> faces = new List<int>();
	
	MeshFilter meshFilter;
	//MeshCollider meshCollider;
	
	void ResetMesh(){
	    vertices.Clear();
		//UVs.Clear();
		vertices.Add(new Vector3(-1,-1,-1));
		vertices.Add(new Vector3(-1,1,-1));
		vertices.Add(new Vector3(1,1,-1));
		vertices.Add(new Vector3(1,-1,-1));
		vertices.Add(new Vector3(-1,1,1));
		vertices.Add(new Vector3(1,1,1));
		vertices.Add(new Vector3(-1,-1,1));
		vertices.Add(new Vector3(1,-1,1));
		 
		colors.Clear();
		//Color[] colors  = new Color[vertices.Count];
		for (var i = 0; i < vertices.Count;i++)
			colors.Add(new Color(0.8f,0.8f,0.8f,1.0f));//Color.Lerp(Color.red, Color.green, vertices[i].y);
		
		triangles.Clear();
		triangles.Add(0);
		triangles.Add(1);
		triangles.Add(2);
		triangles.Add(2);
		triangles.Add(3);
		triangles.Add(0);
		
		triangles.Add(1);
		triangles.Add(4);
		triangles.Add(5);
		triangles.Add(5);
		triangles.Add(2);
		triangles.Add(1);
		
		triangles.Add(4);
		triangles.Add(6);
		triangles.Add(7);
		triangles.Add(7);
		triangles.Add(5);
		triangles.Add(4);
		
		triangles.Add(6);
		triangles.Add(0);
		triangles.Add(3);
		triangles.Add(3);
		triangles.Add(7);
		triangles.Add(6);
		
		triangles.Add(3);
		triangles.Add(2);
		triangles.Add(5);
		triangles.Add(5);
		triangles.Add(7);
		triangles.Add(3);
		
		triangles.Add(6);
		triangles.Add(4);
		triangles.Add(1);
		triangles.Add(1);
		triangles.Add(0);
		triangles.Add(6);
		
		if(!gameObject.GetComponent("MeshFilter"))
			gameObject.AddComponent("MeshFilter");
		if(!gameObject.GetComponent("MeshRenderer"))
			gameObject.AddComponent("MeshRenderer");
		//if(!gameObject.GetComponent("MeshCollider"))
		//	gameObject.AddComponent("MeshCollider");
		if(!gameObject.GetComponent("Rigidbody"))
			gameObject.AddComponent("Rigidbody");
		
		
		
		//meshCollider = gameObject.GetComponent("MeshCollider") as MeshCollider;
		//meshCollider.convex = true;
		//meshCollider.isTrigger = true;
		gameObject.renderer.enabled = false;

	    Mesh mesh = new Mesh {vertices = vertices.ToArray(), triangles = triangles.ToArray()};
	    mesh.RecalculateNormals();
		//mesh.uv = UVs.ToArray();
		
		mesh.colors = colors.ToArray();

        meshFilter = gameObject.GetComponent("MeshFilter") as MeshFilter;
	    if (meshFilter != null) 
            meshFilter.mesh = mesh;

	    //meshCollider.sharedMesh = mesh;
		
		gameObject.renderer.enabled = true;
		
		//renderer.material = new Material(Shader.Find("Vertex Colored"));
		renderer.material = Resources.Load("material") as Material;
		
		GameObject coll = new GameObject();
		coll.AddComponent("BoxCollider");
		coll.transform.localScale*=2;
		coll.transform.parent = transform;
		coll.transform.localPosition = Vector3.zero;
		//Debug.Log(mesh.normals.Length);
	}
	
	
	// Use this for initialization
	public void Start ()
	{
		ResetMesh();
	}

	// Update is called once per frame
    public void FixedUpdate()
	{
		//for(int i=0;i<colors.Count;i++){
		//	colors[i] = new Color(0.8f,0.8f,0.8f,1.0f);	
		//}
		//meshFilter.mesh.colors = colors.ToArray();
		//(gameObject.GetComponent("MeshFilter") as MeshFilter).mesh.t
	}
	public int GetHitFace(RaycastHit hit){
		Vector3 localPos = transform.InverseTransformPoint (hit.point);
		Vector3[] faceCenters = new Vector3[triangles.Count/6];
		Vector3[] faceNorms = new Vector3[triangles.Count/6];
		Vector3 norm = RotateVecByQuat(hit.normal,Quaternion.Inverse(transform.rotation));
		Debug.DrawLine(transform.TransformPoint(localPos),transform.TransformPoint(localPos+100*norm),Color.yellow);
		for(int i=0;i<faceCenters.Length;i++){
			//each face is 2 triangles, each triangle is 3 vertices
			int currFace = i*6;
			Vector3 faceCenter = Vector3.zero;
			List<int> curVerts = new List<int>(4);
			for(int j=0;j<6;j++){
				int curVert = triangles[currFace+j];
				if(!curVerts.Contains(curVert)){
					curVerts.Add(curVert);
					faceCenter+=vertices[curVert];
				}
			}
			faceCenter/=4;
			faceCenters[i] = faceCenter;
			faceNorms[i] = Vector3.Normalize(Vector3.Cross(vertices[curVerts[1]]-vertices[curVerts[0]],vertices[curVerts[3]]-vertices[curVerts[0]]));
			//;
			Debug.DrawLine(transform.TransformPoint(faceCenter),transform.TransformPoint(faceCenter+1*faceNorms[i]),Color.green);
		}
		int closestFace=0;
		for(int i=1;i<faceCenters.Length;i++){
			if(faceNorms[i]==norm&&Vector3.Distance(transform.TransformPoint(faceCenters[i]),hit.point)<Vector3.Distance(transform.TransformPoint(faceCenters[closestFace]),hit.point)){
				closestFace = i;	
			}
		}
		return closestFace;
	}
	public void HighlightFace(RaycastHit hit){
		int curFace = GetHitFace(hit);
		List<int> verts = new List<int>(4);
		
		for(int i=0;i<6;i++){
		 	int curVert = triangles[(curFace*6)+i];
			if(!verts.Contains(curVert))
				verts.Add(curVert);
		}
		for(int i=0;i<4;i++){
			colors[verts[i]] = Color.red;
		}
		meshFilter.mesh.colors = colors.ToArray();
		
		for(int i=0;i<4;i++){
			colors[verts[i]] = new Color(0.8f,0.8f,0.8f,1.0f);
		}
	}
	private static Vector3 RotateVecByQuat(Vector3 a, Quaternion b){
		Quaternion resultQ = b * new Quaternion(a.x,a.y,a.z,0) * Quaternion.Inverse(b);
		return new Vector3(resultQ.x,resultQ.y,resultQ.z);
	}
	
	public void ExtrudeFace(RaycastHit hit){
		List<int> verts = new List<int>(4);
		int curFace = GetHitFace(hit);
		Vector3 norm = RotateVecByQuat(hit.normal,Quaternion.Inverse(transform.rotation));
		
		for(int i=0;i<6;i++){
		 	int curVert = triangles[(curFace*6)+i];
			if(!verts.Contains(curVert)){
				verts.Add(curVert);
			}
			
		}
		
		Vector3 boxCenter = Vector3.zero;
		
		for(int i=0;i<4;i++){
			boxCenter += vertices[verts[i]];
			boxCenter += vertices[verts[i]]+norm*2;
			vertices.Add(vertices[verts[i]]+norm*2);	
			colors.Add(new Color(0.8f,0.8f,0.8f,1.0f));
		}
		boxCenter/=8;
	    Rigidbody rb = gameObject.GetComponent("Rigidbody") as Rigidbody;
	    if(rb != null && rb.IsSleeping())
			rb.WakeUp();
		
		GameObject coll = new GameObject();
		coll.AddComponent("BoxCollider");
		coll.transform.localScale*=2;
		coll.transform.parent = transform;
		coll.transform.localPosition = boxCenter;
		coll.transform.localRotation = Quaternion.identity;
		
		triangles.Add(vertices.Count-4+0);
		triangles.Add(vertices.Count-4+1);
		triangles.Add(vertices.Count-4+2);
		triangles.Add(vertices.Count-4+2);
		triangles.Add(vertices.Count-4+3);
		triangles.Add(vertices.Count-4+0);
		
		triangles.Add(vertices.Count-4+1);
		triangles.Add(triangles[(curFace*6)+1]);
		triangles.Add(triangles[(curFace*6)+2]);
		triangles.Add(triangles[(curFace*6)+2]);
		triangles.Add(vertices.Count-4+2);
		triangles.Add(vertices.Count-4+1);
		
		triangles.Add(triangles[(curFace*6)+0]);
		triangles.Add(vertices.Count-4+0);
		triangles.Add(vertices.Count-4+3);
		triangles.Add(vertices.Count-4+3);
		triangles.Add(triangles[(curFace*6)+4]);
		triangles.Add(triangles[(curFace*6)+0]);
		
		triangles.Add(vertices.Count-4+3);
		triangles.Add(vertices.Count-4+2);
		triangles.Add(triangles[(curFace*6)+2]);
		triangles.Add(triangles[(curFace*6)+2]);
		triangles.Add(triangles[(curFace*6)+4]);
		triangles.Add(vertices.Count-4+3);
		
		triangles.Add(triangles[(curFace*6)+0]);
		triangles.Add(triangles[(curFace*6)+1]);
		triangles.Add(vertices.Count-4+1);
		triangles.Add(vertices.Count-4+1);
		triangles.Add(vertices.Count-4+0);
		triangles.Add(triangles[(curFace*6)+0]);
		
		
		for(int i=5;i>=0;i--){
			triangles.RemoveAt((curFace*6)+i);
		}


	    gameObject.renderer.enabled = false;

	    Mesh mesh = new Mesh {vertices = vertices.ToArray(), triangles = triangles.ToArray()};
	    mesh.RecalculateNormals();
		//mesh.uv = UVs.ToArray();
		
		mesh.colors = colors.ToArray();
		
		meshFilter.mesh = mesh;
		
		//meshCollider.sharedMesh = mesh;
		
		gameObject.renderer.enabled = true;
	}
}

