using UnityEngine;

[ExecuteInEditMode]
public class GameManager : MonoBehaviour
{
	private Texture2D xt;
	public static bool WasLocked{ get; set; }
	private float cameraSpeed = 1;
	
	public static void HandleMouseCursorLocking(){
		
		if(Input.GetKeyDown("escape"))
			UnlockCursor();
		
		if(!Screen.lockCursor && WasLocked){
			WasLocked = false;
			//UnlockCursor();
		}
		else if(Screen.lockCursor&&!WasLocked){
			WasLocked = true;
			//LockCursor();
		}
		
		if(Input.GetMouseButtonDown(0)||Input.GetMouseButtonDown(1))
			LockCursor();
	}
	
	static void LockCursor(){
		Screen.lockCursor = true;
	}
	
	static void UnlockCursor(){
		Screen.lockCursor = false;
	}
	// Use this for initialization
	public void Start ()
	{
		name = "GameManager";
		xt = Resources.Load("xhair") as Texture2D;
	}

    public void OnGUI()
	{
		GUI.DrawTexture(new Rect(Screen.width/2-xt.width/2,Screen.height/2-xt.height/2,xt.width,xt.height),xt);
	}
    public void Update()
    {
		HandleMouseCursorLocking();
		if(Input.GetKeyDown(KeyCode.LeftShift))
			cameraSpeed*=2;
		else if(Input.GetKeyDown(KeyCode.LeftControl))
			cameraSpeed/=2;
		
		if(Screen.lockCursor){
		    Vector3 tr = Input.GetAxis("Horizontal")*new Vector3(1,0,0) + Input.GetAxis("Vertical")*new Vector3(0,0,1);
			tr *= Time.deltaTime * 10;
			Camera.main.transform.Translate(tr*cameraSpeed);

		    float x = Input.GetAxis("Mouse X");
			x *= Time.deltaTime * 50;
			float y = -Input.GetAxis("Mouse Y");
			y *= Time.deltaTime * 50;
			Camera.main.transform.Rotate(y,x,0);
			
			//if(Input.GetMouseButtonDown(0)){
			Ray mouseRay = Camera.main.ScreenPointToRay(new Vector3(Screen.width/2.0f,Screen.height/2.0f,0));
			RaycastHit hit;
			if(Physics.Raycast(mouseRay,out hit)){
				//Debug.Log(hit.triangleIndex);
				if(hit.collider.transform.parent){
					Debug.DrawLine(Vector3.zero,hit.point);
					DigitalClay clay = hit.collider.gameObject.transform.parent.gameObject.GetComponent("DigitalClay") as DigitalClay;
					if(clay){
						clay.HighlightFace(hit);
							
						if(Input.GetMouseButtonDown(0))
							clay.ExtrudeFace(hit);
					}
				}
				
                //Sculptable sculptable = hit.collider.gameObject.GetComponent("Sculptable") as Sculptable;
                //if(sculptable){
                //    sculptable.HighlightFace(hit);
						
                //    if(Input.GetMouseButtonDown(0))
                //        sculptable.ExtrudeFace(hit);
                //}
			}
			//}
			
		}
	}
}

