using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Sculptable : MonoBehaviour
{
	private bool highlightStatus,justChangedHighlight,higlightedThisFrame;
	MeshCollider mC;
	MeshFilter mF;
	GameObject previewTriangle;
	// Use this for initialization
	void Start ()
	{
		mC = GetComponent("MeshCollider") as MeshCollider;
		if(!mC)
			mC = gameObject.AddComponent("MeshCollider") as MeshCollider;
		mF = GetComponent("MeshFilter") as MeshFilter;
		mC.sharedMesh = mF.mesh;
		
		renderer.enabled = false;
		Color[] colors = new Color[mF.mesh.vertices.Length];
		for(int i=0;i<colors.Length;i++)
			colors[i] = new Color(Random.Range(0.0f,1.0f),0.8f,0.8f,1.0f);
		
		mF.mesh.colors = colors;
		//mF.mesh.RecalculateNormals();
		renderer.enabled = true;
		CreatePreviewTriangle();
	}
	void CreatePreviewTriangle(){
		previewTriangle = new GameObject("Selected triangle");
		previewTriangle.transform.parent = transform;
		previewTriangle.transform.localScale = Vector3.one*1.001f;
		previewTriangle.transform.localPosition = Vector3.zero;
		previewTriangle.transform.localRotation = Quaternion.identity;
		previewTriangle.AddComponent("MeshFilter");
		previewTriangle.AddComponent("MeshRenderer");
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh = new Mesh();
		Vector3[] verts = new Vector3[3];
		int[] tris = new int[3];
		Color[] colors = new Color[3];
		for(int i=0;i<3;i++){
			tris[i] = i;
			colors[i] = Color.red;
		}
		
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh.vertices = verts;
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh.triangles = tris;
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh.colors = colors;
		
		previewTriangle.renderer.enabled = false;
	}
	
	// Update is called once per frame
	void Update ()
	{
		if(!highlightStatus){
			if(higlightedThisFrame){
				justChangedHighlight = true;
				highlightStatus = true;
			}
		}
		else{
			if(!higlightedThisFrame){
				justChangedHighlight = true;
				highlightStatus = false;
			}
		}
		if(justChangedHighlight){
			if(!highlightStatus){
				renderer.enabled = false;
				Color[] colors = new Color[mF.mesh.vertices.Length];
				for(int i=0;i<colors.Length;i++)
					colors[i] = new Color(0.2f,0.8f,0.8f,1.0f);
				
				mF.mesh.colors = colors;
				renderer.enabled = true;
			}
		}
		higlightedThisFrame = false;
		justChangedHighlight = false;
		previewTriangle.renderer.enabled = false;
	}
	
	void UpdatePreviewTriangle(int[] indices){
		Vector3[] verts = new Vector3[3];
		for(int i=0;i<3;i++){
			verts[i] = mF.mesh.vertices[indices[i]];
		}
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).renderer.enabled = false;
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh.vertices = verts;
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).mesh.RecalculateNormals();
		(previewTriangle.GetComponent("MeshFilter") as MeshFilter).renderer.enabled = true;
	}
	
	public void HighlightFace(RaycastHit hit){
		higlightedThisFrame = true;
		//Color[] colors = new Color[mF.mesh.colors.Length];
		int[] selectedIndices = new int[3];
		Debug.Log(hit.triangleIndex);
		int curTri = hit.triangleIndex*3;
		
		for(int i=0;i<3;i++){
			selectedIndices[i] = mF.mesh.triangles[curTri+i];
		}
		UpdatePreviewTriangle(selectedIndices);
		
		
	}
	public void ExtrudeFace(RaycastHit hit){
		
	}
	
}

